﻿ if(!window.visionaustralia) window.visionaustralia = {}; visionaustralia.addcolourmap = function(imgId, prox, points){ if (arguments.length != 3) { throw new Error("addcolourmap: pls supply 3 arguments: image id, threshold and array of points"); return; } if (typeof imgId != "string") { throw new Error("addcolourmap: first argument should be id of <img> element"); return; } if (typeof prox != "number") { throw new Error("addcolourmap: second argument should be an integer"); return; } if (prox < 0 || prox > 100) prox = 40; if (! points instanceof Array){ throw new Error("addcolourmap: last argument should be an array"); return; } var img = document.getElementById(imgId); if (!img) { throw new Error("addcolourmap: first argument is not ID of any element"); return; } if (img.nodeName.toLowerCase() != "img") { throw new Error("addcolourmap: first argument is not ID of an image"); return; } var borderCol = "Transparent"; var gzz = 0; doRest(); function doRest(){ if(gzz++ > 10) return; if(!imgOk(img)){ setTimeout(doRest,1000); return; } var bcrImg = img.getBoundingClientRect(); var canvas = document.createElement("canvas"); canvas.style.width = bcrImg.width + "px"; canvas.style.height = bcrImg.height + "px"; canvas.width = bcrImg.width; canvas.height = bcrImg.height; canvas.setAttribute("tabindex","0"); canvas.setAttribute("role","img"); if(img.hasAttribute("class")) canvas.setAttribute("class", img.getAttribute("class")); if(img.hasAttribute("alt")){ var alt = img.getAttribute("alt").trim(); if(alt != ""){ canvas.setAttribute("aria-label",alt); }else{ canvas.setAttribute("aria-label","Interactive graphic"); } }else{ canvas.setAttribute("aria-label","Interactive graphic"); } var ctx = canvas.getContext("2d"); ctx.drawImage(img, 0, 0); img.parentNode.insertBefore(canvas, img); img.parentNode.removeChild(img); var doc = document; var ctx = canvas.getContext("2d"); var yAx = {}; var hoverOb = null; var frozen = false; var x1,y1,x2,y2; var legendObs = {}; legendObs.count = 0; legendObs.first = null; legendObs.last = null; var imgData; imgData=ctx.getImageData(0,0,canvas.width,canvas.height); canvas.addEventListener("click", clickCanvas); canvas.addEventListener("mousemove", mousemoveCanvas); canvas.addEventListener("keydown", keydownCanvas); canvas.addEventListener("focus", focusCanvas); canvas.addEventListener("blur", blurCanvas); for(var i = 0;i<points.length;i++){ addLegendItem(points[i][0],points[i][1]); } function addLegendItem(x,y){ var pixelNumber = (y*canvas.width + x)*4; var r = imgData.data[pixelNumber]; var g = imgData.data[pixelNumber+1]; var b = imgData.data[pixelNumber+2]; var rb = r + prox; var rs = r - prox; var gb = g + prox; var gs = g - prox; var bb = b + prox; var bs = b - prox; function close(rx,gx,bx ){ if(rx < rb && rx > rs && gx < gb && gx > gs && bx < bb && bx > bs){return true;}else{return false;} } var pn = pixelNumber - canvas.width*4; var upCount = 0; while(pn >=0){ if(!close(imgData.data[pn], imgData.data[pn+1],imgData.data[pn+2]))break; upCount++; pn = pn - canvas.width*4; } pn = pixelNumber + canvas.width*4; var downCount = 0; while(downCount <= canvas.height - y){ if(!close(imgData.data[pn], imgData.data[pn+1],imgData.data[pn+2]))break; downCount++; pn = pn + canvas.width*4; } pn = pixelNumber - 4; var leftCount = 0; while(leftCount <= x){ if(!close(imgData.data[pn], imgData.data[pn+1],imgData.data[pn+2]))break; leftCount++; pn = pn - 4; } pn = pixelNumber + 4; var rightCount = 0; while(rightCount <= canvas.width - x){ if(!close(imgData.data[pn], imgData.data[pn+1],imgData.data[pn+2]))break; rightCount++; pn = pn + 4; } var ob = {}; ob.top = y - upCount; ob.left = x - leftCount; ob.width = leftCount + rightCount + 1; ob.height = downCount + upCount + 1; addLegendToEventStructure(ob); if(legendObs.count == 0){ legendObs.first = ob; legendObs.last = ob; ob.prev = ob; ob.next = ob; }else{ legendObs.last.next = ob; ob.prev = legendObs.last; ob.next = legendObs.first; legendObs.first.prev = ob; legendObs.last = ob; } legendObs.count++; ctx.putImageData(imgData,0,0); var imgDataLeg = ctx.getImageData(0,0,canvas.width,canvas.height); for (var i=0,len=imgData.width*imgData.height*4;i<len;i+=4){ var rt = imgDataLeg.data[i]; var gt = imgDataLeg.data[i+1]; var bt = imgDataLeg.data[i+2]; if(close(rt,gt,bt)){ imgDataLeg.data[i] = 0; imgDataLeg.data[i+1] =0; imgDataLeg.data[i+2] = 0; }else{ } } ob.imgDataLeg = imgDataLeg; } function clickCanvas(ev){ if(frozen){ frozen = false; resetMap(); return; } var legOb; bcl = canvas.getBoundingClientRect(); var x = Math.round(ev.clientX - bcl.left); var y = Math.round(ev.clientY - bcl.top); if(yAx[y] && (legOb = yAx[y][x])){ frozen = true; showOnMap(legOb); return; } return; if(locked) return; addLegendItem(x,y); } function mousemoveCanvas(ev){ if(frozen) return; bcl = canvas.getBoundingClientRect(); var x = Math.round(ev.clientX - bcl.left); var y = Math.round(ev.clientY - bcl.top); var ob; if(yAx[y] && (ob = yAx[y][x])){ if(hoverOb == ob) return; showOnMap(ob); }else{ if(hoverOb){ resetMap(); } } } function keydownCanvas(ev){ var keyCode = ev.which || ev.keyCode; if(keyCode == 46){ return; ev.stopPropagation(); ev.preventDefault(); if(!hoverOb) { return; } if(legendObs.count == 1){ legendObs.first = null; legendObs.last = null; }else{ if(legendObs.first == hoverOb) legendObs.first = hoverOb.next; if(legendObs.last == hoverOb) legendObs.last = hoverOb.prev; hoverOb.prev.next = hoverOb.next; hoverOb.next.prev = hoverOb.prev; } legendObs.count--; for(var i=hoverOb.top;i<hoverOb.top + hoverOb.height;i++){ yAx[i] = null; } var H = hoverOb; var o = legendObs.first; for(var g=0;g<legendObs.count;g++){ if((o.top >= H.top && o.top <= H.top + H.height) || (o.top + o.height >= H.top && o.top + o.height <= H.top + H.height) || (o.top < H.top && o.top + o.height > H.top + H.height)){ addLegendToEventStructure(o); } o = o.next; } resetMap(); frozen = false; }else if(keyCode == 13 || keyCode == 32){ ev.stopPropagation(); ev.preventDefault(); if(hoverOb) { if(frozen){ frozen = false; }else{ frozen = true; } }else{ frozen = false; } }else if(keyCode == 27){ ev.stopPropagation(); ev.preventDefault(); frozen = false; resetMap(); }else if(keyCode == 37 || keyCode == 40 ){ if(frozen)return; if(legendObs.count < 1) return; if(!hoverOb){ hoverOb = legendObs.first; }else{ hoverOb = hoverOb.next; } showOnMap(hoverOb); ev.stopPropagation(); ev.preventDefault(); }else if(keyCode == 38 || keyCode == 39 ){ if(frozen)return; if(legendObs.count < 1) return; if(!hoverOb){ hoverOb = legendObs.last; }else{ hoverOb = hoverOb.prev; } showOnMap(hoverOb); ev.stopPropagation(); ev.preventDefault(); } } function focusCanvas(){ canvas.style.outline = "4px solid lightblue"; if(legendObs.count < 1) return; if(!hoverOb){ hoverOb = legendObs.first; } showOnMap(hoverOb); } function blurCanvas(){ canvas.style.outline = "none"; resetMap(); frozen = false; } function resetMap(){ ctx.putImageData(imgData,0,0); var o = legendObs.first; for(var g=0;g<legendObs.count;g++){ drawRec(o,borderCol); o = o.next; } hoverOb = null; } function showOnMap(ob){ ctx.putImageData(ob.imgDataLeg,0,0); var o = legendObs.first; for(var g=0;g<legendObs.count;g++){ drawRec(o,borderCol); o = o.next; } drawRec(ob,"yellow"); hoverOb = ob; } function drawRec(ob,col){ ctx.beginPath(); ctx.lineWidth="2"; ctx.strokeStyle=col; ctx.rect(ob.left,ob.top,ob.width,ob.height); ctx.stroke(); } function addLegendToEventStructure(ob){ for(var i=ob.top;i<ob.top + ob.height;i++){ if(!yAx[i]){ var oo = {}; yAx[i] = oo; } for(var k=ob.left;k<ob.left + ob.width;k++){ yAx[i][k] = ob } } } resetMap(); } function imgOk(img) { if (!img.complete) { return false; } if (typeof img.naturalWidth !== "undefined" && img.naturalWidth === 0) { return false; } return true; } } 